<?php

// include_once('../conexoes/conexaoDevSync.php');
$http_origin = $_SERVER['HTTP_ORIGIN'];
// if ($http_origin == "https://devsync.smartgestorweb.com.br") {
//     header("Access-Control-Allow-Origin: https://devsync.smartgestorweb.com.br");
// }
header('Access-Control-Allow-Origin: *');
header("Access-Control-Allow-Credentials: true");
header("Access-Control-Allow-Methods: POST, GET");
//header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, Authorization");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');


$g = gmdate('D, d M Y H:i:s');
header('Expires: ' . $g . ' GMT');
header('Last-Modified: ' . $g . ' GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

date_default_timezone_set('America/Sao_Paulo');

require_once("../../dompdf/autoload.inc.php");
require("../../PHPMailer-master/src/PHPMailer.php");
require("../../PHPMailer-master/src/SMTP.php");

use Dompdf\Dompdf;

$postjson = json_decode(file_get_contents('php://input'), true);
$cnpj = $postjson['cnpj'];
$anoinicial = $postjson['at']['year'];
$anofinal = $postjson['to']['year'];
$mesinicial = $postjson['at']['month'];
$mesfinal = $postjson['to']['month'];
$dataInicial = $postjson['at']['complete'];
$dataFinal = $postjson['to']['complete'];
$modelo = $postjson['model'];
$empresa = $postjson['enterprise'];
$destiny = $postjson['destiny'];

$array = array();
array_push($array, $destiny);
$emails = $array;
// var_dump($postjson['model']);
// foreach ($array as $key => $value) {
//     var_dump($postjson['destiny']);
// }
// $dataInicial = '2022-09-01';
// $dataFinal = '2022-09-30';
// $cnpj = '22656413000161';
// $modelo = '65';
// $mesinicial = '09';

$dataInicial = new DateTime($dataInicial);
$dataFinal = new DateTime($dataFinal);

// $anoinicial = '22';

$dataInicial = $dataInicial->format('d/m/Y');
$dataFinal = $dataFinal->format('d/m/Y');
//$emails = ['victorramuz23@gmail.com'];


try {
    // Enter the name of directory

    $pathdir = "../../xml/sincronizador/" . $cnpj . "/" . $modelo . "/" . $anoinicial . "/" . $mesinicial . "/";

    if (!file_exists($pathdir)) {
        $result = json_encode(array('success' => false, 'mensagem' => 'Desculpe, não encontramos arquivos para a data selecionada'));
        echo $result;
        return;
    }
    // Enter the name to creating zipped directory
    $zipcreated = "xml-" . $mesinicial . "-" . $anoinicial . ".zip";

    // Create new zip class
    $zip = new ZipArchive;
    if (file_exists($pathdir . $zipcreated)) {
        unlink($pathdir . $zipcreated);
    }


    // $dados = "";
    // $dados = "<tbody>";

    if ($zip->open($pathdir . $zipcreated, ZipArchive::CREATE) === TRUE) {
        // Store the path into the variable
        $dir = opendir($pathdir);

        while ($file = readdir($dir)) {
            if (is_file($pathdir . $file)) {
                // $dados .= "<tr>";
                // $dados .= "<td style='padding: 4px; text-align: left; border-bottom: 1px solid #ddd;'>" . "OI" . "</td>";
                // $dados .= "</tr>";
                $zip->addFile($pathdir . $file, $file);
                $zip->addFromString('../', $file);
            }
        }
        $dados .= "</tbody>";

        $tabela = "<table style='border-collapse: collapse;width: 100%;'><tr><th style='padding: 4px; text-align: left; border-bottom: 1px solid #ddd;'>Nota</th>" . $dados . "</tr></table>";
    }
    $zip->close();

    // return;
} catch (\Exception $th) {
    $result = json_encode(array('success' => false, 'mensagem' => 'Erro ao encontrar arquivos. Tente novamente', 'erro' => $th->getMessage()), JSON_UNESCAPED_UNICODE);
    echo $result;
    return;
}

try {
    $caminhoXml = "https://smartgestorweb.com.br/xml/sincronizador/{$cnpj}/{$modelo}/{$anoinicial}/{$mesinicial}/{$zipcreated}";
    $html = '<!DOCTYPE html>
    <html lang="pt-BR">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="preconnect" href="https://fonts.googleapis.com">
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@100;300;400;700&display=swap" rel="stylesheet">
        <style>
            *{
                margin: 0;
                padding: 0;
            }
            .email-container{
                width: 100%;
                height: 100%;
                background-color: #dfdfdf;
    
                display: flex;
                align-items: center;
                justify-content: center;
            }
            .email{
                width: 500px;
                height: fit-content;
                border-radius: 5px;
                background-color: white;
            }
            .email .header{
                height: 15vh;
                display: flex;
                align-items: center;
                justify-content: center;
                background-color: #6F4A8E;
                border-top-left-radius: 5px;
                border-top-right-radius: 5px;
            }
            .email .header h1{
                color: #EBEBEB;
            }
            .email .body{
                height: calc(100% - 15vh);
                display: flex;
                flex-direction: column;
                align-items: center;
                justify-content: center;
                padding: 5%;
            }
            .email .body .content{
                height: 80%;
                width: 100%;
                margin-bottom: 20px;
            }
            .email .body .content p{
                margin-bottom: 10px;
            }
            .email .body .footer{
                width: 100%;
    
                display: flex;
                align-items: center;
                justify-content: center;
            }
            .email .body .footer a{
                width: 100%;
                height: 45px;
    
                display: flex;
                align-items: center;
                justify-content: center;
    
                background-color: #6F4A8E;
                border-radius: 50px;
                color: #EBEBEB;
                text-decoration: none;
            }
        </style>
    </head>
    <body>
        <div class="email-container">
            <div class="email">
                <div class="header">
                    <h1>&nbsp;DevSync</h1>
                </div>
                <div class="body">
                    <div class="content">
                        <p>Olá, Segue os arquivos de notas fiscais enviadas 😀</p>
                        <p><b>Emitente: </b>' . $empresa . '</p>
                        <p><b>CNPJ: </b>' . $cnpj . '</p>
                        <p><b>Modelo:</b> ' . $modelo . '</p>
                        <p>De ' . $dataInicial . ' a ' . $dataFinal . '</p>
                        <a href="' . $caminhoXml . '" class= "footer">Baixar Notas</a>
                    </div>    
                </div>
                
            </div>
        </div>
    </body>
    </html>';
    $dompdf = new DOMPDF();
    $dompdf->load_html('
                   
                <body style="height: 200px; background-color: white;">
                    <div>                    
                    <h2 style="background-color: #d6d6d6; color: black; margin: 0px; height: 30px; border: 1px solid #6483AF; background-image: linear-gradient(red, yellow);"><img src="../logos/logoarteemcores.jpg" style="float: right; width: 30px; height: 30px;"/>
                    Relatório de Notas 
                                     
                     
                    <br>
                    <br>                 
                    </h2>                    
                    </div>   
                    
                    <strong> ' . $cnpj . ' </strong><br>
                    <strong> Notas referentes ao período de ' . $dataInicial . ' a ' . $dataFinal . ' </strong><br>
                    <br>
                    <br>
                    
                    <br>                   
                    
                    <h3 style="background-color: #d6d6d6;; color: black; width: 725 px;">Notas:</h3>' . $tabela . '<br>                                        
                                      
                    <h3 style="background-color: #d6d6d6; color: black; width: 725 px;">Totais:</h3>                   
                    
                    <strong> Total Geral : </strong> R$ ' . $totalGeral . ' <br>
                    <br>
                                  
                </body>                   
                ');

    $dompdf->render();
    $output = $dompdf->output();
    file_put_contents("pdf/relatorio" . $cnpj . "" . $modelo . "" . $anoinicial . "" . $mesinicial . ".pdf", $output);

    $mail = new PHPMailer\PHPMailer\PHPMailer();
    $mail->IsSMTP(); // enable SMTP
    // $mail->SMTPDebug = 2; // debugging: 1 = errors and messages, 2 = messages only
    $mail->SMTPAuth = true; // authentication enabled
    $mail->SMTPSecure = 'ssl'; // secure transfer enabled REQUIRED for Gmail
    $mail->Host = "mail.smartgestorweb.com.br";
    $mail->Port = 465; // or 587
    $mail->IsHTML(true);
    $mail->Username = "devsync@smartgestorweb.com.br";
    $mail->Password = "Dev2050@";
    $mail->SetFrom("devsync@smartgestorweb.com.br");
    $mail->Subject = "Xml " . $mesinicial . "/" . $anoinicial . " - " . $empresa;
    $mail->Body = $html;
    // $mail->AddAddress('victorramuz23@gmail.com');
    // $mail->Send();
    foreach ($emails as $email) {
        $mail->AddAddress($email);
        $mail->Send();
    }
    //  $mail->AddAddress($emails);
    //  $mail->Send();

    // $mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
    $mail->AddAttachment("pdf/relatorio" . $cnpj . "" . $modelo . "" . $anoinicial . "" . $mesinicial . ".pdf", $name = 'xml.zip',  $encoding = 'base64');
    $result = json_encode(array('emails' => $emails, 'success' => true, 'mensagem' => 'Aguarde, Processando o envio de e-mail '));
    echo $result;
} catch (\Exception $e) {
    $result = json_encode(array('success' => false, 'mensagem' => 'Não foi possível enviar o e-mail. Tente novamente.', 'erro' => $e->getMessage()), JSON_UNESCAPED_UNICODE);
    echo $result;
    return;
}
